Bug 1570047 - Review Request: prestopalette - A tool for artists to create harmonious color palettes
Summary: Review Request: prestopalette - A tool for artists to create harmonious color...
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: William Moreno
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2018-04-20 13:57 UTC by Darryl T. Agostinelli
Modified: 2018-07-18 15:28 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2018-07-18 15:28:30 UTC
Type: Bug
williamjmorenor: fedora-review+


Attachments (Terms of Use)

Description Darryl T. Agostinelli 2018-04-20 13:57:02 UTC
Spec URL: https://raw.githubusercontent.com/PrestoPalette/PrestoPalette-Packaging/master/Fedora/PrestoPalette.spec
SRPM URL: https://kojipkgs.fedoraproject.org//work/tasks/2299/26462299/prestopalette-0.1.31-1.fc29.src.rpm
Description: A tool for artists to create harmonious color palettes

I am in need of a sponsor for my package.  I am the upstream maintainer (original author) of PrestoPalette.
Upstream Link: https://github.com/PrestoPalette/PrestoPalette

# koji build --scratch rawhide ~/rpmbuild/SRPMS/prestopalette-0.1.31-1.fc27.src.rpm 
Results: https://koji.fedoraproject.org/koji/taskinfo?taskID=26461747

# rpmlint prestopalette.spec
0 packages and 1 specfiles checked; 0 errors, 0 warnings.

# fedora-review -n prestopalette
Seems ok.  Please review

# https://copr.fedorainfracloud.org/coprs/dagostinelli/prestopalette/
Failing and the errors do not make sense.  It says that it cannot cd 
into PrestoPalette-0.1.31/  This is strange because mock and koji
work. Also, rpmbuild -bs, -ba and -bi all work.

Comment 1 Robert-André Mauchin 🐧 2018-04-20 14:50:28 UTC
Correct link to SPEC: https://raw.githubusercontent.com/PrestoPalette/PrestoPalette-Packaging/master/Fedora/prestopalette.spec

Comment 2 Robert-André Mauchin 🐧 2018-04-20 14:56:40 UTC
 - No:

%global debug_package %{nil}

   It should be used in last resort, do your best to generate debug symbol

 - Use the macros:

qmake-qt5 -config release PrestoPalette.pro → %qmake_qt5

make %{?_smp_mflags} all → %make_build all

 - Not needed:

%post
update-desktop-database


 - Consider providing an Appdata file. See: https://fedoraproject.org/wiki/Packaging:AppData

 - Simplify the Source0:

Source0:	%{url}/archive/%{version}/%{version}/%{name}-%{version}.tar.gz

Comment 3 Darryl T. Agostinelli 2018-04-21 05:26:40 UTC
Spec URL: https://raw.githubusercontent.com/PrestoPalette/PrestoPalette-Packaging/master/Fedora/prestopalette.spec
SRPM URL: https://kojipkgs.fedoraproject.org//work/tasks/6133/26476133/prestopalette-0.1.31-1.fc29.src.rpm

I have made the adjustments and added a little more since learning how the appdata file worked.

# koji build --scratch rawhide ~/rpmbuild/SRPMS/prestopalette-0.1.31-1.fc27.src.rpm
Results: https://koji.fedoraproject.org/koji/taskinfo?taskID=26476133

# rpmlint prestopalette.spec
0 packages and 1 specfiles checked; 0 errors, 0 warnings.

# fedora-review -n prestopalette
Seems ok.  Please review

# https://copr.fedorainfracloud.org/coprs/dagostinelli/prestopalette/
# https://copr.fedorainfracloud.org/coprs/dagostinelli/prestopalette/build/743705/
COPR builds need work

Comment 4 Darryl T. Agostinelli 2018-04-24 03:22:26 UTC
UPDATE:
- COPR builds are working now for EL7 and Fedora rawhide as well as 26, 27, 28.  
- I've also firmed up the upstream package so that it always does a CI build against Fedora and Centos 7.
- EL6 will not be supported for the moment because the version of Qt5 is too old in EL6.
- I'm personally now using my COPR PPA repository locally.  Works great.

Comment 5 Robert-André Mauchin 🐧 2018-05-03 14:51:45 UTC
 - %{?el7:BuildRequires: gcc-c++}

   You should BR gcc-c++ for Fedora too (disregards the fedora-review message, it's outdated)

BuildRequires: gcc-c++

 - I don't think these Requires are necessary, they should be picked up automatically:

Requires:	qt5-qtbase
Requires:	qt5-qtbase-gui
Requires:	qt5-qtmultimedia

 - The dist tag in the Release field is incorrect:

Release:	1%{?dist}



Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Dist tag is present.


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "MIT/X11 (BSD like)", "Unknown or generated". 124 files have
     unknown license. Detailed output of licensecheck in
     /home/bob/packaging/review/prestopalette/review-
     prestopalette/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package contains desktop file if it is a GUI application.
[x]: Package installs a %{name}.desktop using desktop-file-install or
     desktop-file-validate if there is such a file.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: prestopalette-0.1.31-1.fc29.x86_64.rpm
          prestopalette-debuginfo-0.1.31-1.fc29.x86_64.rpm
          prestopalette-debugsource-0.1.31-1.fc29.x86_64.rpm
          prestopalette-0.1.31-1.fc29.src.rpm
prestopalette.x86_64: W: no-documentation
prestopalette.x86_64: W: no-manual-page-for-binary PrestoPalette
prestopalette-debugsource.x86_64: W: no-documentation
4 packages and 0 specfiles checked; 0 errors, 3 warnings.

Comment 6 Darryl T. Agostinelli 2018-05-07 03:57:52 UTC
Spec URL: https://raw.githubusercontent.com/PrestoPalette/PrestoPalette-Packaging/master/Fedora/prestopalette.spec
SRPM URL: 

Thank you for your detailed review.  I have made the adjustments to the spec file that you noted.

In your review, you also noted the output to rpmlint:

- prestopalette.x86_64: W: no-documentation
- prestopalette.x86_64: W: no-manual-page-for-binary PrestoPalette
- prestopalette-debugsource.x86_64: W: no-documentation

It is not necessary for these files to have a man page or documentation.

- koji build working

$ koji build --scratch rawhide `(ls ~/rpmbuild/SRPMS/prestopalette* | sort -n | head -1)`
Results: https://koji.fedoraproject.org/koji/taskinfo?taskID=26828165

- COPR working

https://copr.fedorainfracloud.org/coprs/dagostinelli/prestopalette/

Comment 8 Robert-André Mauchin 🐧 2018-05-12 16:35:02 UTC
The package is okay to be approved.


To find a sponsor, try introducing yourself on the devel mailing list, and do informal review of other packages to show you understand the Packaging Guidelines.

Comment 9 William Moreno 2018-05-18 20:43:58 UTC
Please re upload the src.rpm

https://kojipkgs.fedoraproject.org//work/tasks/6133/26476133/prestopalette-0.1.31-1.fc29.src.rpm

Not Found
The requested URL /work/tasks/6133/26476133/prestopalette-0.1.31-1.fc29.src.rpm was not found on this server.

Comment 11 William Moreno 2018-06-26 16:43:25 UTC
Please do not use koji to serve src.rpms , koji only keep data for scratch builds for a week, I am building this package locally, looks fine.

Comment 13 William Moreno 2018-06-26 18:01:51 UTC
Package Review
==============


Issues:
=======

Please doble check is this can be move to a -devel package.
[!]: Development files must be in a -devel package
- Header files in -devel subpackage, if present.
  Note: prestopalette-debugsource :
  /usr/src/debug/prestopalette-0.1.31-1.fc29.x86_64/aboutdialog.h
  prestopalette-debugsource :
  /usr/src/debug/prestopalette-0.1.31-1.fc29.x86_64/circlepalette.h
  prestopalette-debugsource :
  /usr/src/debug/prestopalette-0.1.31-1.fc29.x86_64/clickablelabel.h
  prestopalette-debugsource :
  /usr/src/debug/prestopalette-0.1.31-1.fc29.x86_64/gui_aboutdialog.h
  prestopalette-debugsource :
  /usr/src/debug/prestopalette-0.1.31-1.fc29.x86_64/gui_mainwindow.h
  prestopalette-debugsource :
  /usr/src/debug/prestopalette-0.1.31-1.fc29.x86_64/lightingsliderstyle.h
  prestopalette-debugsource :
  /usr/src/debug/prestopalette-0.1.31-1.fc29.x86_64/mainwindow.h
  prestopalette-debugsource :
  /usr/src/debug/prestopalette-0.1.31-1.fc29.x86_64/visualpalette.h
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#DevelPackages

===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
[x]: License file installed when any subpackage combination is installed.
[x]: Package does not own files or directories owned by other packages.   
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package contains desktop file if it is a GUI application.
[x]: Package installs a %{name}.desktop using desktop-file-install or
     desktop-file-validate if there is such a file.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.

Rpmlint
-------
Checking: prestopalette-0.1.31-1.fc29.x86_64.rpm
          prestopalette-debuginfo-0.1.31-1.fc29.x86_64.rpm
          prestopalette-debugsource-0.1.31-1.fc29.x86_64.rpm
          prestopalette-0.1.31-1.fc29.src.rpm
prestopalette.x86_64: W: no-documentation
prestopalette.x86_64: W: no-manual-page-for-binary PrestoPalette
4 packages and 0 specfiles checked; 0 errors, 2 warnings.

Rpmlint (debuginfo)
-------------------
Checking: prestopalette-debuginfo-0.1.31-1.fc29.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
prestopalette-debuginfo.x86_64: W: invalid-url URL: https://github.com/PrestoPalette/PrestoPalette <urlopen error [Errno -2] Name or service not known>
prestopalette.x86_64: W: invalid-url URL: https://github.com/PrestoPalette/PrestoPalette <urlopen error [Errno -2] Name or service not known>
prestopalette.x86_64: W: no-documentation
prestopalette.x86_64: W: no-manual-page-for-binary PrestoPalette
prestopalette-debugsource.x86_64: W: invalid-url URL: https://github.com/PrestoPalette/PrestoPalette <urlopen error [Errno -2] Name or service not known>
3 packages and 0 specfiles checked; 0 errors, 5 warnings.

Requires
--------
prestopalette-debuginfo (rpmlib, GLIBC filtered):

prestopalette (rpmlib, GLIBC filtered):
    libGL.so.1()(64bit)
    libQt5Core.so.5()(64bit)
    libQt5Core.so.5(Qt_5)(64bit)
    libQt5Core.so.5(Qt_5.11)(64bit)
    libQt5Gui.so.5()(64bit)
    libQt5Gui.so.5(Qt_5)(64bit)
    libQt5Multimedia.so.5()(64bit)
    libQt5Multimedia.so.5(Qt_5)(64bit)
    libQt5Network.so.5()(64bit)
    libQt5Widgets.so.5()(64bit)
    libQt5Widgets.so.5(Qt_5)(64bit)
    libc.so.6()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libm.so.6()(64bit)
    libpthread.so.0()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    libstdc++.so.6(CXXABI_1.3.9)(64bit)
    rtld(GNU_HASH)

prestopalette-debugsource (rpmlib, GLIBC filtered):

Provides
--------
prestopalette-debuginfo:
    debuginfo(build-id)
    prestopalette-debuginfo
    prestopalette-debuginfo(x86-64)

prestopalette:
    application()
    application(PrestoPalette.desktop)
    metainfo()
    metainfo(PrestoPalette.appdata.xml)
    prestopalette
    prestopalette(x86-64)

prestopalette-debugsource:
    prestopalette-debugsource
    prestopalette-debugsource(x86-64)

Source checksums
----------------
https://raw.githubusercontent.com/PrestoPalette/PrestoPalette-Packaging/master/Fedora/Icon.png#/PrestoPalette.png :
  CHECKSUM(SHA256) this package     : 3d92aeb896aeb87be37ca0c23150ecee166c9205c4017f4801849f326a73c951
  CHECKSUM(SHA256) upstream package : 3d92aeb896aeb87be37ca0c23150ecee166c9205c4017f4801849f326a73c951
https://github.com/PrestoPalette/PrestoPalette/archive/0.1.31/0.1.31.tar.gz#/prestopalette-0.1.31.tar.gz :
  CHECKSUM(SHA256) this package     : bdad1bec87a1a8c53f95c841d66f298f8a0ada858f7baa3e69ae168796d8b313
  CHECKSUM(SHA256) upstream package : bdad1bec87a1a8c53f95c841d66f298f8a0ada858f7baa3e69ae168796d8b313
https://raw.githubusercontent.com/PrestoPalette/PrestoPalette-Packaging/master/Fedora/PrestoPalette.appdata.xml#/PrestoPalette.appdata.xml :
  CHECKSUM(SHA256) this package     : e96a60e52af9e8f57c22f5076cdfaf6f51d79167852dcb85c28f4fac9362f41e
  CHECKSUM(SHA256) upstream package : e96a60e52af9e8f57c22f5076cdfaf6f51d79167852dcb85c28f4fac9362f41e

Comment 14 Darryl T. Agostinelli 2018-07-04 15:11:08 UTC
A -devel subpackage isn't needed for this project since a desktop app only and an end user isn't expected to build a derivative project from this.  No building with its headers is expected. The .h files aren't installed with the rpm.

Is it ready to go?

Comment 15 William Moreno 2018-07-04 16:49:20 UTC
OK

If so I am fine with this package.

PACKAGE APROVED
===============

I have added you the packager group in FAS, wait a few hours to the change to be synced in the Fedora Infra and request you new package to be added to the distribution.

Comment 16 Gwyn Ciesla 2018-07-05 13:59:00 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/prestopalette

Comment 17 Darryl T. Agostinelli 2018-07-18 15:28:30 UTC
Thanks everyone!


Note You need to log in before you can comment on or make changes to this bug.